# Supported algorithms

The library aims to support a few core algorithms that will be well suited for production use and other algorithms that are interesting to compare against.

*  [Uniformly sampled](https://github.com/nfrechette/acl/blob/develop/docs/algorithm_uniformly_sampled.md)
*  Linear key reduction (TODO)
*  Curve key reduction (TODO)
*  Wavelets (TODO)

# How to integrate the library

*  [Handling asserts](https://github.com/nfrechette/acl/blob/develop/docs/handling_asserts.md)
*  [Implementing an allocator](https://github.com/nfrechette/acl/blob/develop/docs/implementing_an_allocator.md)
*  Creating a skeleton
*  Creating a clip
*  Compressing a clip
*  Decompressing a clip

# Performance metrics

*  [ACL vs Unreal 4 vs Unity 5](https://github.com/nfrechette/acl/blob/develop/docs/acl_vs_ue4_vs_unity.md)

# Miscellaneous

*  [The ACL file format](https://github.com/nfrechette/acl/blob/develop/docs/the_acl_file_format.md)
*  [Rotation and vector formats](https://github.com/nfrechette/acl/blob/develop/docs/rotation_and_vector_formats.md)
*  [Error metrics](https://github.com/nfrechette/acl/blob/develop/docs/error_metrics.md)
*  [Why we don't use 64-bit floats](https://github.com/nfrechette/acl/blob/develop/docs/no_64bit_math.md)
